<?php

namespace Teknisa\EST\Modules\Ajuste\Factories;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

use Doctrine\ORM\EntityManager;
    
class Est43000ManutencaoDoUltimoCustoFactory {
    
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function verificaIndice1($params) {
        $sql = "SELECT VRINDICE
          FROM  INDICE I, MOVINDICE M, PARAMGERAL P
          WHERE I.CDTPINDICE = P.CDTPINDICE AND
                I.IDPERVALOR = P.IDPERVALOR AND
                I.CDINDICE   = P.CDINDICEMF AND
                P.CDINDICEMF IS NOT NULL    AND
                I.CDTPINDICE = M.CDTPINDICE AND
                I.IDPERVALOR = M.IDPERVALOR AND
                I.CDINDICE   = M.CDINDICE   AND
                M.DTREFIND   = :P_DTREFIND";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function verificaIndice2($params) {
        $sql = "SELECT VRINDICE
              FROM  INDICE I, MOVINDICE M, PARAMGERAL P
              WHERE I.CDTPINDICE = P.CDTPINDICE2  AND
                    I.IDPERVALOR = P.IDPERVALOR2  AND
                    I.CDINDICE   = P.CDINDICEMF2  AND
                    P.CDINDICEMF IS NOT NULL      AND
                    I.CDTPINDICE = M.CDTPINDICE   AND
                    I.IDPERVALOR = M.IDPERVALOR   AND
                    I.CDINDICE   = M.CDINDICE     AND
                    M.DTREFIND   = :P_DTREFIND";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function buscaProdutosParaImportacao($params) {
        $sql = "SELECT C.NRORG,
              NVL(VRLIQCMPPROD,0) AS VRLIQCMPPROD,
              NVL(VRBRUCMPPROD,0) AS VRBRUCMPPROD,
              NVL(VRLIQCMPPRM1,0) VRLIQCMPPRM1,
              NVL(VRLIQCMPPRM2,0) VRLIQCMPPRM2,
              NVL(VRBRUCMPPRM1,0) VRBRUCMPPRM1,
              NVL(VRBRUCMPPRM2,0) VRBRUCMPPRM2,
              C.CDFILIAL,
              C.CDPRODUTO,
              P.CDARVPROD,
              P.SGUNIDADE,
              P.NMPRODUTO,
              P.CDPRODESTO,
              PF.IDPRODATIV,
              DTCUSTCMPPRO,
              C.NRLOTEESTQ,
              C.NRSUBLOTE,
              C.CDALMOXARIFE,
              C.CDLOCALESTOQ,
              PF.IDUTCTRLLOTE
            FROM CUSTOCMPPROD C,
              PRODUTO P,
              PRODFILI PF
            WHERE C.CDFILIAL            = :CDFILIAL
            AND C.CDALMOXARIFE          = NVL(:CDALMOXARIFE, ' ')
            AND C.CDLOCALESTOQ          = NVL(:CDLOCALESTOQ, ' ')
            AND NVL(P.IDPRODATIVPR,'S') = 'S'
            AND C.CDPRODUTO             = P.CDPRODUTO
            AND PF.CDFILIAL             = C.CDFILIAL
            AND C.CDPRODUTO             = PF.CDPRODUTO
            AND P.CDPRODUTO             = P.CDPRODESTO
            AND(P.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN)
            AND DTCUSTCMPPRO =
              (SELECT MAX(D.DTCUSTCMPPRO)
              FROM CUSTOCMPPROD D
              WHERE D.CDFILIAL    = :CDFILIAL
              AND D.CDALMOXARIFE  = C.CDALMOXARIFE
              AND D.CDLOCALESTOQ  = C.CDLOCALESTOQ
              AND D.CDPRODUTO     = C.CDPRODUTO
              AND D.NRLOTEESTQ    = C.NRLOTEESTQ
              AND D.NRSUBLOTE     = C.NRSUBLOTE
              AND D.DTCUSTCMPPRO <= :DTREFERENCIA
              )";
             
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function insereLote($params) {
        $sql = "INSERT INTO LOTE
            (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
            (SELECT :CDFILIAL CDFILIAL, :NRLOTEESTQ NRLOTEESTQ, :NRSUBLOTE NRSUBLOTE, :CDPRODUTO CDPRODUTO,
            'L' IDSTATLOTE, SYSDATE DTENTRLOTE
            FROM PARAMGERAL
            MINUS
            SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE, :CDPRODUTO CDPRODUTO, 'L', SYSDATE
            FROM LOTE
            WHERE :CDFILIAL   =  CDFILIAL     AND
                  :NRLOTEESTQ =  NRLOTEESTQ   AND
                  :NRSUBLOTE  =  NRSUBLOTE    AND
                  :CDPRODUTO  =  CDPRODUTO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deletaCusto($params) {
         $sql="DELETE
            FROM CUSTOCMPPROD
            WHERE CDFILIAL   = :CDFILIAL
            AND CDALMOXARIFE = NVL(:CDALMOXARIFE, '')
            AND CDLOCALESTOQ = NVL(:CDLOCALESTOQ, '')
            AND CDPRODUTO    = :CDPRODUTO
            AND NRLOTEESTQ   = :NRLOTEESTQ
            AND NRSUBLOTE    = :NRSUBLOTE
            AND DTCUSTCMPPRO = :DTREFERENCIA";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function atualizaManutUltCusto($params) {
        $sql = "UPDATE CUSTOCMPPROD
            SET VRLIQCMPPROD    = :P_VRULTCMPLIQ,
                  VRBRUCMPPROD  = :P_VRULTCMPBRU,
                  VRLIQCMPPRM1  = :P_VRULTCMPLM1,
                  VRLIQCMPPRM2  = :P_VRULTCMPLM2,
                  VRBRUCMPPRM1  = :P_VRULTCMPBM1,
                  VRBRUCMPPRM2  = :P_VRULTCMPBM2,
          WHERE CDFILIAL               = :P_CDFILIMOVI         AND
                CDALMOXARIFE   = NVL(:P_CDALMOXARIFE, ' ')     AND
                CDLOCALESTOQ   = NVL(:P_CDLOCALESTOQ, ' ')     AND
                NRLOTEESTQ     = NVL(:P_NRLOTEESTQ,  ' ')       AND
                NRSUBLOTE      = NVL(:P_NRSUBLOTE, ' ')        AND
                CDPRODUTO      = :P_CDPRODMOVI       AND
                DTCUSTCMPPRO   = :P_DTLANCMOVI";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function atualizaUltimoCusto(
    $P_FILIAL, $P_PRODINI, $P_PRODFIM, $P_CDALMOXARIFE, $P_CDLOCALESTOQ, $P_TALMOX, $P_TLOCAL, $P_DTINICIAL, $P_DTFINAL) {
        $procedure = new StoredProcedure($this->entityManager->getConnection(),'ATUALIZA_CUSTO_COMPRA');
        $procedure->addParam(new Param(
                "P_FILIAL",
                Param::PARAM_INPUT,
                $P_FILIAL,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_PRODINI",
                Param::PARAM_INPUT,
                $P_PRODINI,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_PRODFIM",
                Param::PARAM_INPUT,
                $P_PRODFIM,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_CDALMOXARIFE",
                Param::PARAM_INPUT,
                $P_CDALMOXARIFE,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_CDLOCALESTOQ",
                Param::PARAM_INPUT,
                $P_CDLOCALESTOQ,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_TALMOX",
                Param::PARAM_INPUT,
                $P_TALMOX,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_TLOCAL",
                Param::PARAM_INPUT,
                $P_TLOCAL,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_DTINICIAL",
                Param::PARAM_INPUT,
                $P_DTINICIAL,
                Param::PARAM_TYPE_STR
        ));
        $procedure->addParam(new Param(
                "P_DTFINAL",
                Param::PARAM_INPUT,
                $P_DTFINAL,
                Param::PARAM_TYPE_STR
        ));
        return $procedure->execute();
    }

    public function getProducts($params) {
        $sql = "SELECT CDPRODUTO,
                  NMPRODUTO,
                  CDNVPRODUTO,
                  SGUNIDADE,
                  CDPRODESTO,
                  CDARVPROD
                FROM PRODUTO
                WHERE CDNVPRODUTO = :CDNVPRODUTO
                AND CDPRODUTO     = CDPRODESTO
                AND IDPRODATIVPR  = 'S'
                ORDER BY CDARVPROD";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
