/* Sistemas Integrados TEKNISA

Nome: 8830_SUPTRGO.sql

Descrio:
Trigger para incluso de todos os fornecedores na
tabela REFORFIL para a filial que estiver sendo inserida.

Com essa trigger, ao incluir uma filial, automaticamente o sistema ir
considerar que nenhum fornecedor atende  mesma.

Criao:
07/12/2004 Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER GRAVA_REFORFIL_FILIAL
AFTER INSERT OR UPDATE OF CDREGIAO
ON FILIAL FOR EACH ROW
BEGIN
   IF NVL(:NEW.CDREGIAO, '') <> NVL(:OLD.CDREGIAO, '') THEN
      FOR C_REFORFIL IN
         (SELECT
             :NEW.CDFILIAL CDFILIAL,
             CDFORNECED
          FROM
             FORNECEDOR)
      LOOP
         UPDATE REFORFIL SET
            CDPERIENTR = NULL
         WHERE
            CDFILIAL   = C_REFORFIL.CDFILIAL AND
            CDFORNECED = C_REFORFIL.CDFORNECED;
         IF SQL%NOTFOUND THEN
            INSERT INTO REFORFIL
               (CDFILIAL, CDFORNECED)
            VALUES
               (C_REFORFIL.CDFILIAL, C_REFORFIL.CDFORNECED);
         END IF;
      END LOOP;
   END IF;
END;
/
